---
title: DocumentFragment.querySelector()
slug: Web/API/DocumentFragment/querySelector
tags:
  - API
  - DOM
  - DocumentFragment
  - Method
---
<div>{{ApiRef("DOM")}}</div>

<p>The <strong><code>DocumentFragment.querySelector()</code></strong> method returns the first element, or <code>null</code> if no matches are found, within the {{domxref("DocumentFragment")}} (using depth-first pre-order traversal of the document's nodes) that matches the specified group of selectors.</p>

<p>If the selector matches an ID and this ID is erroneously used several times in the document, it returns the first matching element.</p>

<p>If the selectors specified in parameter are invalid a {{domxref("DOMException")}} with a <code>SYNTAX_ERR</code> value is raised.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>element</em> = <em>documentfragment</em>.querySelector(<em>selectors</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><em>selectors </em></dt>
	<dd>Is a {{domxref("DOMString")}} containing one or more CSS selectors separated by commas.</dd>
</dl>

<h2 id="Example">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>In this basic example, the first element in the {{domxref("DocumentFragment")}} with the class "<code>myclass</code>" is returned:</p>

<pre class="brush: js">var el = documentfragment.querySelector(".myclass");
</pre>

<h3 id="CSS_syntax_and_the_method's_argument">CSS syntax and the method's argument</h3>

<p>The string argument pass to <code>querySelector</code> must follow the CSS syntax. To match ID or selectors that do not follow the CSS syntax (by using semicolon or space inappropriately for example), it's mandatory to escape the wrong character with a double back slash:</p>

<pre class="brush: html">&lt;div id="foo\bar"&gt;&lt;/div&gt;
&lt;div id="foo:bar"&gt;&lt;/div&gt;

&lt;script&gt;
document.querySelector('#foo\bar')    // Does not match anything
document.querySelector('#foo\\\\bar') // Match the first div
document.querySelector('#foo:bar')     // Does not match anything
document.querySelector('#foo\\:bar')   // Match the second div
&lt;/script&gt;
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Selectors API Level 2', '#queryselector', 'DocumentFragment.querySelector')}}</td>
			<td>{{Spec2('Selectors API Level 2')}}</td>
			<td>No change from {{SpecName('Selectors API Level 1')}}</td>
		</tr>
		<tr>
			<td>{{SpecName('Selectors API Level 1', '#queryselector', 'DocumentFragment.querySelector')}}</td>
			<td>{{Spec2('Selectors API Level 1')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_Compatibility">Browser compatibility</h2>

<p>{{Compat("api.DocumentFragment.querySelector")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>The {{domxref("DocumentFragment")}} interface it belongs to.</li>
</ul>
